#include "ipcpacket.h"

IPCPacket::IPCPacket()
{   
    m_needed = SIZE_FIELD_LENGTH + SIZE_FIELD_SERVICE_BYTE;
    m_size_buf = new unsigned char[m_needed];
    m_size = 0;
    m_buffer = NULL;    
}

IPCPacket::~IPCPacket()
{
    delete[] m_buffer;
    delete[] m_size_buf;
}

unsigned char* IPCPacket::readBuffer()
{
    if (m_buffer)
    {
        return m_buffer + m_size - m_needed;
    }
    else
    {
        return m_size_buf + SIZE_FIELD_SERVICE_BYTE + SIZE_FIELD_LENGTH - m_needed;
    }
}

unsigned long IPCPacket::readNeeded()
{
    return m_needed;
}

void IPCPacket::readResult(unsigned long readed)
{
    m_needed -= readed;

    if ((m_buffer == NULL) && (m_needed == 0))
    {
        m_size = *((unsigned long*)(m_size_buf + SIZE_FIELD_SERVICE_BYTE));
        m_needed = m_size - SIZE_FIELD_LENGTH - SIZE_FIELD_SERVICE_BYTE;
        m_buffer = new unsigned char[m_size];
        memcpy(m_buffer, m_size_buf, SIZE_FIELD_LENGTH + SIZE_FIELD_SERVICE_BYTE);
    }

}

IPCPacket* IPCPacket::Create(unsigned long type, char* sender, unsigned char* data, unsigned long data_len)
{
    IPCPacket* ipcp = new IPCPacket();

    int sender_len = strlen(sender);

    ipcp->m_size = SIZE_FIELD_LENGTH + SIZE_FIELD_TYPE + sender_len + 3 + data_len;
    ipcp->m_buffer = new unsigned char[ipcp->m_size];

    ipcp->m_buffer[0] = SERVICE_BYTE;

    memcpy(ipcp->m_buffer + OFFSET_FIELD_LENGTH, &ipcp->m_size, SIZE_FIELD_LENGTH);
    int count = SIZE_FIELD_LENGTH + OFFSET_FIELD_LENGTH;

    memcpy(ipcp->m_buffer + count, &type, SIZE_FIELD_TYPE);
    count += SIZE_FIELD_TYPE;

    memcpy(ipcp->m_buffer + count, sender, sender_len);
    count += sender_len;

    ipcp->m_buffer[count++] = '\0';

    memcpy(ipcp->m_buffer + count, data, data_len);
    count += data_len;

    ipcp->m_buffer[count] = SERVICE_BYTE;

    return ipcp;
}
IPCPacket* IPCPacket::wrapCreate(unsigned long type, char* sender, unsigned char* data, unsigned long data_len)
{
    return IPCPacket::Create(type, sender, data, data_len);
}

unsigned char* IPCPacket::getBuffer()
{
    return m_buffer;
}

unsigned long IPCPacket::getSize()
{
    return *((unsigned long*)(m_buffer + OFFSET_FIELD_LENGTH));
}

unsigned long IPCPacket::getType()
{
    return *((unsigned long*)(m_buffer + OFFSET_FIELD_TYPE));
}

char* IPCPacket::getSender()
{
    return (char*)(m_buffer + SENDER_OFFSET);
}

unsigned char* IPCPacket::getData()
{
    return (unsigned char*)(m_buffer + SENDER_OFFSET + strlen(getSender()) + 1);
}

unsigned char* IPCPacket::readBuffer(unsigned long datagramm_size)
{
    m_size = datagramm_size;
    m_buffer = new unsigned char[m_size];

    return m_buffer;
}

bool IPCPacket::IsValid()
{
    return (m_buffer[0] == SERVICE_BYTE) && (m_buffer[m_size - 1] == SERVICE_BYTE) && (m_size == *((unsigned long*)(m_buffer + OFFSET_FIELD_LENGTH)) );
}

unsigned long IPCPacket::getDataLen()
{
    return m_size - SIZE_FIELD_LENGTH - SIZE_FIELD_TYPE - strlen(getSender()) - 3;
}

extern "C" IPCPacket* getPacketFactory() {
  return new IPCPacket;
}
