//! \file framelogin.cpp Реализация класса формы аутентификации пользователя
#include "./include/framelogin.h"
#include "ui_framelogin.h"

//! Конструктор класса
/**
  * \param parent объект-родитель
  */
FrameLogin::FrameLogin(QWidget *parent) :
    QFrame(parent),
    ui(new Ui::FrameLogin)
{
    ui->setupUi(this);    
    ui->lineEdit_login->setFocus();
}

//! Деструктор класса
FrameLogin::~FrameLogin()
{
    delete ui;
}

//! Получение кнопки подтверждения логина
/**
  * \return указатель на объект-кнопку QPushButton
  */
QPushButton* FrameLogin::getButtonLogin()
{
    return ui->pushButton_enter;
}

//! Получение введенного логина
/**
  * \return логин пользователя, представленный в виде строки типа QString
  */
QString FrameLogin::getLogin()
{
    return ui->lineEdit_login->text();
}

//! Получение введенного пароля
/**
  * \return пароль пользователя, представленный в виде строки типа QString
  */
QString FrameLogin::getPassword()
{
    return ui->lineEdit_password->text();
}

//! Установка логина
/**
  * Устанавливает в поле ввода логина, логин, переданный по значению
  * \param login логин пользователя
  */
void FrameLogin::setLogin(const QString &login)
{
    ui->lineEdit_login->setText(login);
}

//! Установка пароля
/**
  * Устанавливает в поле ввода пароля, пароль, переданный по значению
  * \param login логин пользователя
  */
void FrameLogin::setPassword(const QString &login)      // О___о TODO: login --> password
{
    ui->lineEdit_password->setText(login);
}

//! Получение метки с логином
/**
  * \return указатель на объект-метку QLabel
  */
QLabel* FrameLogin::getLabelLogin()
{
    return ui->label_login;
}

//! Получение метки с паролем
/**
  * \return указатель на объект-метку QLabel
  */
QLabel* FrameLogin::getLabelPassword()
{
    return ui->label_password;
}

//! Получение кнопки создания аккаунта
/**
  * \return указатель на объект-кнопку QPushButton
  */
QPushButton* FrameLogin::getButtonCreateAccount()
{
    return ui->pushButton_create_account;
}
