//! \file filesdb.h Описание класса работы с БД
#include <vector>
#include <fstream>
#include <pthread.h>
#include "main.h"
#include "sync_obj.h"

using namespace std;
//! Класс работы с БД
class filedb
{
public:
	filedb(string fpath);
	filedb();
	~filedb();
	void dbset(string);
	int load();
	int save();
	int unlock();
	int lock();
	sync_object* insert(string);
	sync_object* insert(sync_object);
	int remove(string);
	int erase(sync_object*);
	int next(sync_object*&);
	int nextall(sync_object*&);
	int combine(vector<sync_object>);
	sync_object* find(string);
	sync_object* find_wd(int wd);
	vector<sync_object*> findDir(string fpath);
	void delDeleted();

private:
	pthread_mutex_t m_lock;		//!< Блокировка БД
	string path;			//!< Путь к файлу БД
	ifstream* f_db;			//!< Поток файла БД
	vector<sync_object*> m_db;	//!< Список объектов, загруженных из БД
};
