//! \file ipc_proxy.h Реализация класса взаимодействия с IPCPacket
//! \todo убрать или переписать непосредственно на ipc_interface.h
#ifndef IPC_PROXY_H
#define IPC_PROXY_H
#include "ipc_interface.h"
#include "ipc_interface_local.h"

#include <string>

#include "../../psyncconfig/include/ipc_interface.h"
#include "../../psyncnotify/include/ipc_interface.h"

//! класс взаимодействия с IPCPacket
class ipc_proxy
{
public:
	//! тип пакета 
	enum status{
		NONE,		//!< нет
		SYNC_START,	//!< начало синхронизации
		SYNC_STOP,	//!< остановка синхронизации
		SYNC_STATUS,	//!< статус синхронизации
		FILE_ADD,	//!< добавить файл
		FILE_DEL,	///< удалить файл
		FILE_STATUS,	///< статус файла
		DIR_STATUS,	///< статус директории
		REQ_LOGIN,	///< запрос логина
		ACC_VALID,	///< аккаунт валиден
		PWD_CHANGED,	///< пароль изменен
		NOTE_MSG,	///< нотификационное сообщение
		SET_CHANGED,	///< настройки изменились
		LIST_ALL,	///< список всехфайлов
		CONFLICT,	///< конфликт при синхронизации
		FILE_CONFLICT,	///< конфликт при ссохранении файла
		FILE_DIALOG,
	};

	ipc_proxy(const char* path);
	~ipc_proxy();
	int next();
	int nextb();
	std::string from() {return fpath;} ///< Получить путь сокета отправителя сообщения
	int send_old(status st,const char* path, std::string ret=std::string());
	int send(int type,std::string path, std::string ret=std::string());
	inline status getState() {return state;} //!< получить тип пакета

	int check_connect(const char* address);

	std::string getData();
private:
	status state;		///< Тип пакета
	std::string data;	///< Данные пакета
	int sock;		///< Сокет отправки
	std::string spath;	///< Путь своего сокета
	std::string fpath;	///< Путь к сокету полученного сообщения
};
#endif
