//! \file main.h Основной заголовочный файл приложения
#ifndef MAIN_H
#define MAIN_H
#include "ipc_proxy.h"

//! Глобальная структура соединения
struct http_ctx
{
	std::string creds;	 //!< верительные грамоты
	std::string host;	 //!< адрес хоста
	unsigned short port;	 //!< порт на сервере
	std::string path;	 //!< путь к своему сокету
	std::string home;	 //!< путь к $HOME
	std::string pathConfig;	 //!< путь к сокету конфига
	std::string pathNotify;	 //!< путь к сокету нотификатора
	int conflict_flag;	 //!< флаг обработки конфликта
	ipc_proxy* ipc;		 //!< указатель на класс ipc взаимодействий
	bool ssl;		 //!< флаг работы с SSL
	bool stopflag;		 //!< флаг экстренной остановки
	int timeout;		 //!< таймаут ля разрешения коллизий
	std::string file_path;   //!< путь к файлу для повторного сохранения
	bool file_conflict_flag; //!< флаг обработки конфликта сохранения файла
	bool file_wait_flag;     //!< флаг ожидания выбора директории
	bool path_rename;        //!< флаг замены локальноко пути файла на новый
}; 

extern http_ctx conn_ctx;

extern int neon_counter;
extern bool neon_operation;

#endif
