//! \file sync.h Объявление класса контекста синхронизации
#include <string>
#include "WebDAV.h"
#include "ipc_proxy.h"
#include "filesdb.h"
#include "main.h"
using namespace std;

//! Класс контекста синхронизации
class syncronizer
{
public:
	syncronizer(string srv,unsigned short port,string col);
	~syncronizer();
	int dbconnect(string);

	int addFile(string);
	int removeFile(string path);
	string checkDir(string);
	int checkFile(string path);
	string listAll();

	void fthread();
	void athread();
	void stop();
	int start();
	void syncAll();
	void syncStop();
	int TryAuth();//{return dav.TryAuth();};
	void setSyncTime(int sec);//0 -отключить
	void setMode(int _mode);
	void setIPC(ipc_proxy* i){ipc=i;}	//!< Установка указателя на класс межпроцессорного взаимодействия
	int is_work();
	
	void setFileOperation() { file_operation=true; };

	void startAuto();
	void stopAuto();
	
	//! Режимы синхронизации
	enum mode_e{
		MODE_NONE, 	//!< Синхронизация отключена
		MODE_TIME,	//!< Синхронизация по времени
		MODE_AUTO,	//!< Автоматическая синхронизация
	};
private:
	int sync();
	ipc_proxy* ipc;		//!< Указатель на класс межпроцессорного взаимодействия
	filedb db;		//!< База данных файлов в синхронизации
	
	int mode;	//!< Режим работы контекста синхронизации

	pthread_t th;		//!< Дескриптор потока периодической синхронизации 
	pthread_t ath;		//!< Дескриптор потока автоматической синхронизации
	int is_working;		//!< Флаг работы потока периодической синхронизации 
	int stopflag;		//!< Флаг экстренной остановки синхронизации
       	int automode;		//!< Флаг работы потока автоматической синхронизации
	pthread_spinlock_t lock;	//!< Спинболкировка синхронизации
	int sync_time;		//!< Таймер синхронизации
	int def_synctime;	//!< Текущий период синхронизации
	bool file_operation;	//!< Было ли произведено добавление/удаление файла

};
