//! \file ipc_wrap.cc Реализация технологического консольного приложения для посылки сообщений демону
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "include/ipc_interface_local.h"
#include "include/ipc_interface.h"
#include "include/ipc_proxy.h"
#include <iostream>
#define HOME_ENV "HOME"	//!< Название переменной окружения $HOME
using namespace std;
//! Главная функция приложения 
/**
 * параметры командной строки:
 * 	add добавление файла
 * 	remove удаление файла
 * 	sync запуск синхронизации
 * 	cnt ??
 * 	list получение списка файлов
 */
int main(int argc, char* argv[])
{
	if(argc < 2){
		cerr<<"usage: psyncctl <add|remove|sync|cnt|list> [filename]"<<endl;
		return 0;
	}
	try{
		char* he=getenv(HOME_ENV);
		if(!he)
			throw "Ошибка получения $HOME";
		string home(he);
		home+="/";home+=FOLDER_NAME;home+="/";
		string pathSync=home+SYNCRONIZE_PROGRAM_NAME;
		string pathDolphin=home+DOLPHIN_PROGRAM_NAME;
		string pathNotify=home+PSYNCNOTIFY_IPC_NAME;

		ipc_proxy ipc(pathDolphin.c_str());
		if(string(argv[1])=="add")
			ipc.send(PSYNCD_ADD_TO_SYNC_COMMAND, ".psyncclient/psyncd", string(argv[2]));
		if(string(argv[1])=="sync")
			ipc.send(PSYNCD_SYNC_START, ".psyncclient/psyncd");
		if(string(argv[1])=="stop")
			ipc.send(PSYNCD_SYNC_STOP, ".psyncclient/psyncd");
		if(string(argv[1])=="remove")
			ipc.send(PSYNCD_REMOVE_TO_SYNC_COMMAND, ".psyncclient/psyncd", string(argv[2]));
		if(string(argv[1])=="cnt")
			ipc.send_old(ipc_proxy::NOTE_MSG, pathNotify.c_str(), string(argv[2]));
		if(string(argv[1])=="list"){
			if(argc==3){
				ipc.send(PSYNCD_GET_FILES_FROM_FOLDER_COMMAND, ".psyncclient/psyncd",string(argv[2]));
				sleep(1);
				ipc.nextb();
				cerr<<ipc.getData()<<endl;
			}else{
				ipc.send(PSYNCD_GET_ALL_FILES_COMMAND, ".psyncclient/psyncd");
				sleep(1);
				ipc.nextb();
				cerr<<ipc.getData()<<endl;
			}
		}
	}
	catch(const char* ch)
	{
		cerr<< ch<<endl;
	}
}
